scala.collection.mutable

# HashTable

###
Related Doc: package mutable

#### trait HashTable[A, Entry >: Null <: HashEntry[A, Entry]] extends HashUtils[A]

This class can be used to construct data structures that are based on hashtables. Class `HashTable[A]` implements a hashtable that maps keys of type `A` to values of the fully abstract member type `Entry`. Classes that make use of `HashTable` have to provide an implementation for `Entry`.

There are mainly two parameters that affect the performance of a hashtable: the initial size and the load factor. The size refers to the number of buckets in the hashtable, and the load factor is a measure of how full the hashtable is allowed to get before its size is automatically doubled. Both parameters may be changed by overriding the corresponding values in class `HashTable`.

A

  type of the elements contained in this hash table.

Source
  HashTable.scala
Version

  2.0, 31/12/2006

Since

  1

Linear Supertypes
HashUtils[A], AnyRef, Any
Known Subclasses
HashMap, LinkedHashMap, LinkedHashSet, ParHashMap, ParHashTable
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. HashTable
2. HashUtils
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def createNewEntry[B](key: A, value: B): Entry

   Creates new entry to be immediately inserted into the hashtable.

   Creates new entry to be immediately inserted into the hashtable. This method is guaranteed to be called only once and in case that the entry will be added. In other words, an implementation may be side-effecting.

   Attributes
     protected

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from HashTable[A, Entry] to any2stringadd[HashTable[A, Entry]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (HashTable[A, Entry], B)

   Implicit information
     This member is added by an implicit conversion from HashTable[A, Entry] to ArrowAssoc[HashTable[A, Entry]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### var _loadFactor: Int

   Attributes
     protected

7. #### def addEntry(e: Entry): Unit

   Add entry to table pre: no entry with same key exists

   Add entry to table pre: no entry with same key exists

   Attributes
     protected
   Annotations
     @deprecatedOverriding( ... , "2.11.0" )

8. #### def alwaysInitSizeMap: Boolean

   Attributes
     protected

9. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

10. #### def calcSizeMapSize(tableLength: Int): Int

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

11. #### def clearTable(): Unit

    Remove all entries from table

    Remove all entries from table

    Attributes
      protected

12. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

13. #### def elemEquals(key1: A, key2: A): Boolean

    Attributes
      protected

14. #### def elemHashCode(key: A): Int

    Attributes
      protected
    Definition Classes
      HashUtils

15. #### def ensuring(cond: (HashTable[A, Entry]) ⇒ Boolean, msg: ⇒ Any): HashTable[A, Entry]

    Implicit information
      This member is added by an implicit conversion from HashTable[A, Entry] to Ensuring[HashTable[A, Entry]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: (HashTable[A, Entry]) ⇒ Boolean): HashTable[A, Entry]

    Implicit information
      This member is added by an implicit conversion from HashTable[A, Entry] to Ensuring[HashTable[A, Entry]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean, msg: ⇒ Any): HashTable[A, Entry]

    Implicit information
      This member is added by an implicit conversion from HashTable[A, Entry] to Ensuring[HashTable[A, Entry]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: Boolean): HashTable[A, Entry]

    Implicit information
      This member is added by an implicit conversion from HashTable[A, Entry] to Ensuring[HashTable[A, Entry]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def entriesIterator: Iterator[Entry]

    An iterator returning all entries.

    An iterator returning all entries.

    Attributes
      protected

20. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

21. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

22. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

23. #### def findEntry(key: A): Entry

    Find entry with given key in table, null if not found.

    Find entry with given key in table, null if not found.

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

24. #### def findOrAddEntry[B](key: A, value: B): Entry

    Find entry with given key in table, or add new one if not found.

    Find entry with given key in table, or add new one if not found. May be somewhat faster then `findEntry`/`addEntry` pair as it computes entry's hash index only once. Returns entry found in table or null. New entries are created by calling `createNewEntry` method.

    Attributes
      protected

25. #### def foreachEntry[U](f: (Entry) ⇒ U): Unit

    Avoid iterator for a 2x faster traversal.

    Avoid iterator for a 2x faster traversal.

    Attributes
      protected

26. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from HashTable[A, Entry] to StringFormat[HashTable[A, Entry]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

27. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

28. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

29. #### final def improve(hcode: Int, seed: Int): Int

    Attributes
      protected
    Definition Classes
      HashUtils

30. #### final def index(hcode: Int): Int

    Attributes
      protected

31. #### def initWithContents(c: Contents[A, Entry]): Unit

    Attributes
      protected

32. #### def initialSize: Int

    The initial size of the hash table.

    The initial size of the hash table.

    Attributes
      protected

33. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

34. #### def isSizeMapDefined: Boolean

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

35. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

36. #### def nnSizeMapAdd(h: Int): Unit

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

37. #### def nnSizeMapRemove(h: Int): Unit

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

38. #### def nnSizeMapReset(tableLength: Int): Unit

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

39. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

40. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

41. #### def removeEntry(key: A): Entry

    Remove entry from table if present.

    Remove entry from table if present.

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

42. #### var seedvalue: Int

    Attributes
      protected

43. #### final def sizeMapBucketBitSize: Int

    Attributes
      protected
    Definition Classes
      HashUtils

44. #### final def sizeMapBucketSize: Int

    Attributes
      protected
    Definition Classes
      HashUtils

45. #### def sizeMapDisable(): Unit

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

46. #### def sizeMapInit(tableLength: Int): Unit

    Attributes
      protected

47. #### def sizeMapInitAndRebuild(): Unit

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

48. #### var sizemap: Array[Int]

    The array keeping track of the number of elements in 32 element blocks.

    The array keeping track of the number of elements in 32 element blocks.

    Attributes
      protected

49. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

50. #### var table: Array[HashEntry[A, Entry]]

    The actual hash table.

    The actual hash table.

    Attributes
      protected

51. #### var tableSize: Int

    The number of mappings contained in this hash table.

    The number of mappings contained in this hash table.

    Attributes
      protected

52. #### def tableSizeSeed: Int

    Attributes
      protected

53. #### var threshold: Int

    The next size value at which to resize (capacity * load factor).

    The next size value at which to resize (capacity * load factor).

    Attributes
      protected

54. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

55. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

56. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

57. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

58. #### def →[B](y: B): (HashTable[A, Entry], B)

    Implicit information
      This member is added by an implicit conversion from HashTable[A, Entry] to ArrowAssoc[HashTable[A, Entry]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from HashUtils[A]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from HashTable[A, Entry] to any2stringadd[HashTable[A, Entry]]

### Inherited by implicit conversion StringFormat from HashTable[A, Entry] to StringFormat[HashTable[A, Entry]]

### Inherited by implicit conversion Ensuring from HashTable[A, Entry] to Ensuring[HashTable[A, Entry]]

### Inherited by implicit conversion ArrowAssoc from HashTable[A, Entry] to ArrowAssoc[HashTable[A, Entry]]

### Ungrouped